EM_ASS(VI)

NAME
em_ass - EM assembler/loader

SYNOPSIS
/usr/em/lib/em_ass [options] argument ...

DESCRIPTION
Em_ass assembles and links EM modules. Arguments may be flags, EM modules or libraries. Flags recognized are:

-ss, -sm, -sl
    Indicate that your program is small, medium or large. Medium is the default.

-p  List all procedure names together with base-address (decimal and octal), procedure number and module of definition.

-d  Used for debugging em_ass itself.

em_ass assembles and links together compact EM assembly language modules from files and libraries, producing an e.out file as described in [1].

Two different types of arguments are allowed:

1 - Compact EM assembly language modules (optimized or not), recognized by a magic number in the first word.
2 - UNIX archives, as maintained by arch(I). These archives must contain EM modules only.

EM modules may contain a library message specifying the names of procedures and external data defined inside the module. These will only be loaded if they contain definitions of procedures or data imported by previously assembled modules. When ack(I) is provided with the -LIB flag it tells the EM-optimizer em_opt(VI) to insert a library messages when optimizing modules. The EM-archiver arch(I) can be used to create libraries from EM modules.

Note that it is not possible to do a partial load; loading starts from compact EM code and produces binary EM code. No symbol table and no relocation bits are produced.

SEE ALSO
ack(I), arch(I)
[1] A.S. Tanenbaum, Hans van Staveren, Ed Keizer and Johan Stevenson "Description of a machine architecture for use with block structured languages" Informatica report IR-81.

DIAGNOSTICS
Various diagnostics may be produced. In the case of compiler produced code the only messages to expect are "Out of memory" or of the form: Overflow in XXXX. The latter can usually be cured by giving a -sl flag, the former means your program is too big, dimishing the size of very large procedures can sometimes help. The most likely errors, however, are unresolved references, probably caused by the omission of a library argument.

AUTHOR
Ed Keizer, Vrije Universiteit